;##################################################################
; Vertical Toolbar
;##################################################################

#include "VertToolbar.Inc"

;#include "\RadASM\GoAsm\inc\debug.a"
;DBGWIN_DEBUG_ON = 1 ; use this to enable Spy/StopSpy/DbgDump and TrapException
;DBGWIN_SHOWONLYERRORS = 1 ; setting this to 1 will suppress PrintError if no error exists 

.CONST
	TOPMSG				equ			2048
	IDD_DLG1			equ			1000
	IDC_MENUBAR			equ			4000
	MENUBASEID			equ			4001
	IDC_REBAR			equ			4500
	IDC_REBARBAND		equ			4501
	USER_TBDROPDOWN		equ			WM_USER + 200
	FONTBASEID			equ			6001

.DATA
	MsgTable			DD			TOPMSG DUP (?)

	hInstance			DD 			?
	icc	 				DQ			3FFF00000008h

	hMenuToolBar		DD			?
	hHook				DD			?
	hMenus				DD			6 DUP (?)
	hPopMenu			DD			?
	hRebar				DD			?
	hBmp				DD			?
	hTBBkGrnd			DD			?
	hMNBrush			DD			?
	hChkIML				DD			?
	hFontMenu			DD			?

	CurrentBtn			DD			0
	CurrentFont			DD			0
	nItemNum			DD			0

	hDlg				DD			0

	nmtb				NMTOOLBAR	<>

	EditMnuItem0		db "Copy",0
	EditMnuItem1		db "Cut",0
	EditMnuItem2		db "Paste",0
	EditMnuItem3		db "Delete",0
	EditMnuItem4		db "Select All",0
	EditMnuItem5		db "Invert Selection",0

	FileMnuItem0		db "Open",0
	FileMnuItem1		db "Save",0
	FileMnuItem2		db "Save As",0
	FileMnuItem3		db "Exit",0

	HelpMnuItem0		db "Help",0
	HelpMnuItem1		db "About",0

	TbStrings			db "File",0
						db "Edit",0
						db "Font",0
						db "Help",0,0

	; Start the button IDs at one so we don't use 0 (we'll have to dec in order to get the right menu)
	MenuBtns			TBBUTTON	<0,MENUBASEID + 0,TBSTATE_ENABLED,TBSTYLE_AUTOSIZE | TBSTYLE_DROPDOWN,0,0,0>
						TBBUTTON	<1,MENUBASEID + 1,TBSTATE_ENABLED,TBSTYLE_AUTOSIZE | TBSTYLE_DROPDOWN,0,0,1>
						TBBUTTON	<2,MENUBASEID + 2,TBSTATE_ENABLED,TBSTYLE_AUTOSIZE | TBSTYLE_DROPDOWN,0,0,2>
						TBBUTTON	<3,MENUBASEID + 3,TBSTATE_ENABLED,TBSTYLE_AUTOSIZE | TBSTYLE_DROPDOWN,0,0,3>
	MenuTBend:
	nMenuBtns			equ			(MenuTBend-MenuBtns) /SIZEOF TBBUTTON

	DefaultFont			LOGFONT		<-13,0,0,0,FW_NORMAL,FALSE,FALSE,0,0,0,0,0,0,"MS Sans Serif">

.CODE
BuildMessageTable:
	uses edi,ecx,eax
		; Set the default proc for all messages to WM_USER+1023
		mov edi,OFFSET MsgTable
		mov ecx,TOPMSG-1
		mov eax,OFFSET DEFPROC
		rep stosd
		; Set the offsets of the messages to process
		mov [MsgTable+(WM_INITDIALOG *4)],OFFSET WMINITDIALOG
		mov [MsgTable+(WM_COMMAND *4)],OFFSET WMCOMMAND
		mov [MsgTable+(WM_CLOSE *4)],OFFSET WMCLOSE
		mov [MsgTable+(WM_NOTIFY *4)],OFFSET WMNOTIFY
		mov [MsgTable+(USER_TBDROPDOWN *4)],OFFSET USERTBDROPDOWN
		mov [MsgTable+(WM_MEASUREITEM *4)],OFFSET WMMEASUREITEM
		mov [MsgTable+(WM_DRAWITEM *4)],OFFSET WMDRAWITEM
		ret
	endu

Start:
	call BuildMessageTable
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitCommonControlsEx,OFFSET icc
	invoke CreateSolidBrush,00FF8080h
	mov [hMNBrush],eax
	; load the check marks image list from the resource section of our app
	invoke ImageList_LoadImage,[hInstance],5004,11,10,0FFFFFFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
	mov [hChkIML],eax
	call BuildMenus
	invoke DialogBoxParam,[hInstance],IDD_DLG1,0,ADDR DlgProc,0
	invoke DestroyMenu,[hMenus+0]
	invoke DestroyMenu,[hMenus+4]
	invoke DestroyMenu,[hMenus+8]
	invoke DestroyMenu,[hMenus+12]
	invoke ExitProcess,0

SuperClassEdit FRAME
	LOCAL wc	:WNDCLASSEX
	
	RET
ENDF

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses ebx,esi,edi
	LOCAL rect		:RECT
	LOCAL pt		:POINT
	LOCAL lf		:LOGFONT
	LOCAL lbr		:LOGBRUSH
	LOCAL mii		:MENUITEMINFO

	mov eax,[uMsg]
	cmp eax,TOPMSG-1
	ja >DEFPROC
	jmp [MsgTable+eax*4]

	WMINITDIALOG:
		mov eax,[hwnd]
		mov [hDlg],eax
		invoke GetDlgItem,[hwnd],IDC_MENUBAR
		mov [hMenuToolBar],eax
		invoke GetDlgItem,[hwnd],IDC_REBAR
		mov [hRebar],eax
		invoke CreateMenuToolBar
		invoke CreateFontIndirect,OFFSET DefaultFont
		invoke SendDlgItemMessage,[hwnd],1001,WM_SETFONT,eax,TRUE
		jmp >>.EXIT

	WMCOMMAND:
		; Get the command ID
		movzx eax,W[wParam]
		cmp eax,FONTBASEID
		jl >>
		cmp eax,[nItemNum]
		jg >>
		; Set up the MENUITEMINFO structure
		mov D[mii.cbSize],SIZEOF MENUITEMINFO
		mov D[mii.fMask],MIIM_DATA
		mov D[mii.dwItemData],0
		; Extract the information from this menu item
		invoke GetMenuItemInfo,[hFontMenu],eax,MF_BYCOMMAND,OFFSET mii
		; Make sure that it has a font handle in dwItemData
		cmp D[mii.dwItemData],0
		je >>.EXIT
			; Extract the LOGFONT information for this menu item
			; We will use that as a starting point for creating a new
			; font for use in the edit control
			invoke GetObject,[mii.dwItemData],SIZEOF LOGFONT,OFFSET lf
			; Modify the LOGFONT structure based on the users choices
			; do not modify the lf.lfFaceName or lf.lfPitchAndFamily members
			mov eax,-15 ; Display height of font
			mov [lf.lfHeight],eax
			mov D[lf.lfWidth],0
			; Create a new font for the edit
			invoke CreateFontIndirect,OFFSET lf
			mov ebx,eax
			; Get the old font and delete it
			; if there was no user selected font it will be a
			; system defined font (Stock Object) and it does no
			; harm to delete it anyway
			invoke SendDlgItemMessage,[hwnd],1001,WM_GETFONT,0,0
			invoke DeleteObject,eax ; destroy the old display font
			; Set the new font for the edit, redraw must be set to TRUE
			invoke SendDlgItemMessage,[hwnd],1001,WM_SETFONT,ebx,TRUE
			; Reset the checkmark on the old font (ID stored in [CurrentFont])
			invoke CheckMenuItem,[hFontMenu],[CurrentFont],MF_BYCOMMAND + MF_UNCHECKED
			; Set the checkmark in the new font selection and update [CurrentFont]
			xor eax,eax
			mov ax,W[wParam]
			mov [CurrentFont],eax
			invoke CheckMenuItem,[hFontMenu],eax,MF_BYCOMMAND + MF_CHECKED
		:
		cmp ax,6204 ; Exit
		jne >
			invoke EndDialog,[hwnd],0
			jmp >>DEFPROC
		:
		jmp >>.EXIT

	WMDRAWITEM:
		; If wParam is 0 then Windows is asking to draw a menu item
		cmp D[wParam],0
		jne >>DEFPROC
			; lParam hold a pointer to the DRAWITEMSTRUCT structure
			; We will use this structure to give us references for drawing
			; Just to make sure this is a menu we will verify the control type
			mov edi,[lParam]
			mov eax,[edi+DRAWITEMSTRUCT.CtlType]
			test eax,ODT_MENU
			je >DEFPROC
				; itemAction tells us what type of drawing is taking place
				; for menus we need to draw for ODA_DRAWENTIRE and ODA_SELECT
				; for our purpose we will not distinguish between itemActions
				; Get the item state (either selected or not)
				mov eax,[edi+DRAWITEMSTRUCT.itemState]
				test eax,ODS_SELECTED
				je >>S1
					; This menu item is selected so we will use the menu
					; brush, first we need the color of the brush for the
					; font background color
					mov ebx,0FFFFFFh
					mov esi,[hMNBrush]
					invoke GetObject,esi,SIZEOF LOGBRUSH,OFFSET lbr
					push [lbr.lbColor]
					jmp >S2
				S1:
					; This menu item is not selected so we will create a
					; brush from COLOR_BUTTONFACE
					mov ebx,0
					invoke GetSysColor,COLOR_BTNFACE
					push eax
					invoke CreateSolidBrush,eax
					mov esi,eax
				S2:
					pop eax
					invoke SetBkColor,[edi+DRAWITEMSTRUCT.hdc],eax
					push eax ; push the old background color

					; Set the text color to WHITE
					invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],ebx
					push eax ; push the old text color

					; The itemData member has our font handle we need to extract the
					; name of the font to draw it
					invoke GetObject,[edi+DRAWITEMSTRUCT.itemData],SIZEOF LOGFONT,OFFSET lf

					; Select the font into the menu's DC so any text will be drawn with that font
					invoke SelectObject,[edi+DRAWITEMSTRUCT.hdc],[edi+DRAWITEMSTRUCT.itemData]
					push eax ; Push the old object onto the stack

					; Calculate the offset of the bounding RECT structure for the item
					; we are drawing
					mov ebx,edi
					add ebx,DRAWITEMSTRUCT.rcItem

					; Fill the bounding rectangle with the selection brush
					invoke FillRect,[edi+DRAWITEMSTRUCT.hdc],ebx,esi
					
					; Get the indent we will need to draw the text and add it to the left
					; side of the rect, we don't have to return this structure so we will
					; write directly to it
					invoke GetMenuCheckMarkDimensions
					and eax,0FFFFh ; The low order word contains the width
					add [edi+DRAWITEMSTRUCT.rcItem.left],eax

					invoke lstrlen,OFFSET lf.lfFaceName
					or eax,eax
					jnz >
						invoke lstrcpy,OFFSET lf.lfFaceName,"Custom font"
					:
					; Draw the text and restore all of the objects and colors
					invoke DrawText,[edi+DRAWITEMSTRUCT.hdc],OFFSET lf.lfFaceName,-1,ebx,DT_LEFT + DT_VCENTER + DT_SINGLELINE
					pop eax
					invoke SelectObject,[edi+DRAWITEMSTRUCT.hdc],eax
					pop eax
					invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],eax
					pop eax
					invoke SetBkColor,[edi+DRAWITEMSTRUCT.hdc],eax

					; Draw the check mark if necessary
					mov ebx,edi
					add ebx,DRAWITEMSTRUCT.rcItem
					invoke GetMenuCheckMarkDimensions
					and eax,0FFFFh ; The low order word contains the width
					sub [edi+DRAWITEMSTRUCT.rcItem.left],eax

					; Center the image vertically we need to know the height of the checkmark
					invoke ImageList_GetIconSize,[hChkIML],OFFSET rect.left,OFFSET rect.top
					or eax,eax
					jne >
						; No image list or an error so don't draw it
						jmp >S3
					:
					mov ecx,[edi+DRAWITEMSTRUCT.rcItem.bottom]
					sub ecx,[edi+DRAWITEMSTRUCT.rcItem.top]
					sub ecx,[rect.left]
					shr ecx,1
					add [edi+DRAWITEMSTRUCT.rcItem.top],ecx

					; Is the menu item checked ??
					xor eax,eax
					test D[edi+DRAWITEMSTRUCT.itemState],MF_CHECKED
					je >
						inc eax
					:
					invoke ImageList_Draw,[hChkIML],eax,[edi+DRAWITEMSTRUCT.hdc],[ebx+RECT.left],[ebx+RECT.top],ILD_NORMAL

					mov eax,[edi+DRAWITEMSTRUCT.itemState]
					test eax,ODS_SELECTED
					jne >S3
						; Destroy the brush if it was a normal menu item
						invoke DeleteObject,esi
				S3:
					xor eax,eax
					inc eax
					ret

	WMMEASUREITEM:
		; The WM_MEASUREITEM message is sent for owner drawn controls
		; to tell Windows how big it will be
		; lParam hold a pointer to the MEASUREITEMSTRUCT structure
		; We will return this structure with the measurements of our control
		mov edi,[lParam]
		; If wParam is 0 then Windows is asking to measure a menu item
		cmp D[wParam],0
		jne >DEFPROC
			; Just to make sure this is a menu we will verify the control type
			mov eax,[edi+MEASUREITEMSTRUCT.CtlType]
			test eax,ODT_MENU
			je >DEFPROC
				; To measure the size of the text we must select it into a DC
				; We create a memory DC for this
				invoke GetDC,NULL
				mov ebx,eax
				invoke CreateCompatibleDC,ebx
				mov esi,eax
				invoke SelectObject,esi,[edi+MEASUREITEMSTRUCT.itemData]
				; Save the old object in the DC on the stack
				push eax
				; We stored the font handle in the lParam of the menu item
				; it is passed in MEASUREITEMSTRUCT.itemData, we will use that
				; to read the full LOGFONT structure to get the font name
				invoke GetObject,[edi+MEASUREITEMSTRUCT.itemData],SIZEOF LOGFONT,OFFSET lf
				; we need the length of the name
				invoke lstrlen,OFFSET lf.lfFaceName
				; Have Windows calculate the width and height of the string
				; This function takes a POINT structure but we will just reuse the rect
				; structure used elsewhere to limit the DlgProc stack size
				invoke GetTextExtentPoint32,esi,OFFSET lf.lfFaceName,eax,OFFSET rect
				; Pop the old object in the DC off the stack and select it back into the DC
				pop ecx
				invoke SelectObject,esi,ecx
				; Delete the memory DC and release the screen DC
				invoke DeleteDC,esi
				invoke ReleaseDC,NULL,ebx
				; We need to know how much space to leave for a check mark
				; This information is obtained from GetMenuCheckMarkDimensions
				; add it to the left side of the rectangle (width)
				invoke GetMenuCheckMarkDimensions
				mov edx,eax
				shr edx,16 ; The high order word contains the height (EDX)
				and eax,0FFFFh ; The low order word contains the width (EAX)
				add eax,[rect.left]
				; Set the width of this item
				mov D[edi+MEASUREITEMSTRUCT.itemWidth],eax
				; if our height is below the height of a checkmark we 
				; set it to that value
				add edx,2 ; make sure we leave a pixel on the top and bottom
				mov ecx,[rect.top]
				cmp ecx,edx
				ja >
					mov ecx,edx
				:
				mov D[edi+MEASUREITEMSTRUCT.itemHeight],ecx
				xor eax,eax
				inc eax
				ret

	WMNOTIFY:
		mov edi,[lParam]
		cmp D[edi+NMHDR.code],TBN_DROPDOWN
		jne >>.TBN_HOTITEMCHANGE
		cmp D[edi+NMHDR.idFrom],IDC_MENUBAR
		jne >>.WMN_DONE
		USERTBDROPDOWN:
			mov edi,[lParam]
			mov eax,[edi+NMTOOLBAR.iItem]
			invoke SendMessage,[hMenuToolBar],TB_COMMANDTOINDEX,eax,0
			invoke SendMessage,[hMenuToolBar],TB_GETITEMRECT,eax,ADDR rect
			mov eax,[rect.right]
			mov [pt.x],eax
			mov eax,[rect.top]
			mov [pt.y],eax
			invoke ClientToScreen,[hMenuToolBar],ADDR pt
			mov eax,[edi+NMTOOLBAR.iItem]
			sub eax,MENUBASEID
			mov eax,[hMenus+eax*4]
			mov [hPopMenu],eax
			cmp D[hHook],0
			jne >
				invoke UnhookWindowsHookEx,[hHook]
				mov D[hHook],NULL
			:
			; direct import from TBMenuHook.dll
			invoke TBMenuHook.dll:InstallHook,[hMenuToolBar]
			mov [hHook],eax
			invoke SendMessage,[hMenuToolBar],TB_PRESSBUTTON,[edi+NMTOOLBAR.iItem],TRUE
			invoke TrackPopupMenu,[hPopMenu],TPM_LEFTALIGN + TPM_RETURNCMD,[pt.x],[pt.y],NULL,[hMenuToolBar],NULL
			or eax,eax
			jz >
				invoke SendMessage,[hwnd],WM_COMMAND,eax,0
			:
			invoke SendMessage,[hMenuToolBar],TB_PRESSBUTTON,[edi+NMTOOLBAR.iItem],FALSE
			invoke UnhookWindowsHookEx,[hHook]
			mov D[hHook],NULL
			invoke UpdateWindow,[hwnd]
			xor eax,eax
			inc eax
			ret

		.TBN_HOTITEMCHANGE
			cmp D[edi+NMHDR.code],TBN_HOTITEMCHANGE
			jne >>.WMN_DONE
			cmp D[edi+NMHDR.idFrom],IDC_MENUBAR
			jne >>.WMN_DONE
			mov edi,[lParam]
			invoke SendMessage,[hMenuToolBar],TB_GETSTATE,[edi+NMTBHOTITEM.idNew],0
			test eax,TBSTATE_ENABLED
			jz >Z2
			cmp D[hHook],0
			jne >Z2
			Z1:
				xor eax,eax
				inc eax
				ret
			Z2:
			mov eax,[edi+NMTBHOTITEM.idNew]
			push eax
			or eax,eax
			jz <Z1
			cmp eax,[CurrentBtn]
			jz <Z1
			invoke SendMessage,[hMenuToolBar],TB_PRESSBUTTON,[CurrentBtn],FALSE
			pop eax
			mov eax,[edi+NMTBHOTITEM.idNew]
			mov [CurrentBtn],eax
			mov [nmtb.iItem],eax
			mov eax,[hMenuToolBar]
			mov [nmtb.hdr.hwndFrom],eax
			mov D[nmtb.hdr.code],TBN_DROPDOWN
			mov D[nmtb.hdr.idFrom],IDC_MENUBAR
			invoke SendMessage,[hMenuToolBar],WM_CANCELMODE,0,0
			invoke PostMessage,[hwnd],USER_TBDROPDOWN,0,OFFSET nmtb
			xor eax,eax
			inc eax
			ret

		.WMN_DONE
		xor eax,eax
		ret


	WMCLOSE:
		INVOKE EndDialog,[hwnd],0

	DEFPROC:
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

BuildMenus:
	uses edi

	mov edi,OFFSET hMenus

	invoke CreatePopupMenu
	mov [edi+0],eax
	invoke AppendMenu,[edi+0],MF_STRING,6201,OFFSET FileMnuItem0
	invoke AppendMenu,[edi+0],MF_STRING,6202,OFFSET FileMnuItem1
	invoke AppendMenu,[edi+0],MF_STRING,6203,OFFSET FileMnuItem2
	invoke AppendMenu,[edi+0],MF_STRING,6204,OFFSET FileMnuItem3

	invoke CreatePopupMenu
	mov [edi+4],eax
	invoke AppendMenu,[edi+4],MF_STRING,6101,OFFSET EditMnuItem0
	invoke AppendMenu,[edi+4],MF_STRING,6102,OFFSET EditMnuItem1
	invoke AppendMenu,[edi+4],MF_STRING,6103,OFFSET EditMnuItem2
	invoke AppendMenu,[edi+4],MF_STRING,6104,OFFSET EditMnuItem3
	invoke AppendMenu,[edi+4],MF_STRING,6105,OFFSET EditMnuItem4
	invoke AppendMenu,[edi+4],MF_STRING,6106,OFFSET EditMnuItem5

	invoke CreatePopupMenu
	mov [edi+8],eax
	mov [hFontMenu],eax
	; Enumerate the fonts and add them to the menu, enumerate for ANSI_CHARSET
	invoke BuildFontMenu,eax,ANSI_CHARSET

	invoke CreatePopupMenu
	mov [edi+12],eax
	invoke AppendMenu,[edi+12],MF_STRING,6301,OFFSET HelpMnuItem0
	invoke AppendMenu,[edi+12],MF_STRING,6302,OFFSET HelpMnuItem1

	ret
endu

CreateMenuToolBar FRAME
	LOCAL	rct			:RECT
	LOCAL	rbbi		:REBARBANDINFO
	LOCAL	maxsize		:D

	invoke SetParent,[hMenuToolBar],[hRebar]

	invoke ImageList_LoadImage,[hInstance],5000,16,10,0FF00FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
	invoke SendMessage,[hMenuToolBar],TB_SETIMAGELIST,0,eax

	invoke ImageList_LoadImage,[hInstance],5002,16,10,0FF00FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
	invoke SendMessage,[hMenuToolBar],TB_SETDISABLEDIMAGELIST,0,eax

	invoke SendMessage,[hMenuToolBar],TB_BUTTONSTRUCTSIZE,SIZEOF TBBUTTON,0

	invoke SendMessage,[hMenuToolBar],TB_ADDSTRING,NULL,OFFSET TbStrings
	invoke SendMessage,[hMenuToolBar],TB_ADDBUTTONS,nMenuBtns,OFFSET MenuBtns

	; find the widest button
	;###
	mov D[maxsize],0
	mov edi,0
	R1:
		invoke SendMessage,[hMenuToolBar],TB_GETITEMRECT,edi,Addr rct
		mov ecx,[rct.right]
		sub ecx,[rct.left]
		cmp ecx,[maxsize]
		jle >
			mov [maxsize],ecx
		:
		inc edi
		or eax,eax
	jnz <R1

	; make the widest button the minimum size
	mov eax,[maxsize]
	mov [rbbi.cyMinChild],eax

	mov D[rbbi.cbSize],SIZEOF REBARBANDINFO
	mov D[rbbi.fMask],RBBIM_CHILD + RBBIM_ID + RBBIM_SIZE + RBBIM_CHILDSIZE ;or RBBIM_STYLE
	mov eax,[hMenuToolBar]
	mov [rbbi.hwndChild],eax
	mov D[rbbi.clrFore],00FFFFFFh
	mov D[rbbi.clrBack],0
	mov D[rbbi.fStyle],RBBS_FIXEDSIZE
	mov D[rbbi.lx],16
	mov D[rbbi.cxMinChild],16
	mov D[rbbi.cxIdeal],16
	mov D[rbbi.wID],IDC_REBARBAND

	invoke SendMessage,[hRebar],RB_INSERTBAND,-1,ADDR rbbi
	invoke SendMessage,[hMenuToolBar],TB_SETROWS,1,addr rct
	invoke SendMessage,[hMenuToolBar],TB_AUTOSIZE,0,0

	ret

ENDF

BuildFontMenu FRAME SubMenuHandle,CharSet
	uses ebx,esi
	LOCAL lf	:LOGFONT

	; To enumerate the fonts we must suuply the information in
	; a LOGFONT structure to control the enumeration. The API will
	; read the lfCharSet, lfFaceName and lfPitchAndFamily members of
	; the structure. Always set the lfPitchAndFamily member to 0. If
	; you wish to enumerate all families set lfFaceName to 0. It is
	; good idea to supply a character set or you may get multiple
	; instances of the same font (one for each character set)
	; For the purposes of the menu we pass the menu handle of the Font menu
	; to the enumerator in lParam, this let's it add the menu items directly
	; as part of the enumeration
	mov D[nItemNum],FONTBASEID
	mov eax,[CharSet]
	mov B[lf.lfCharSet],al
	mov B[lf.lfFaceName],0
	mov B[lf.lfPitchAndFamily],0 
	invoke GetDlgItem,[hDlg],1001
	mov esi,eax
	invoke GetDC,esi
	mov ebx,eax
	invoke EnumFontFamiliesEx,ebx,ADDR lf,OFFSET EnumFontFamExProc,[SubMenuHandle],0
	invoke ReleaseDC,esi,ebx
	RET
ENDF

EnumFontFamExProc FRAME lpelfe,lpntme,FontType,lParam
	uses ebx

	; Get the data from the font and create a font of a fixed height
	; for the menu to display
	mov ebx,[lpelfe]
	add ebx,ENUMLOGFONTEX.elfLogFont
	mov D[ebx+LOGFONT.lfHeight],-13
	mov D[ebx+LOGFONT.lfWidth],0
	mov D[ebx+LOGFONT.lfWeight],FW_NORMAL
	invoke CreateFontIndirect,ebx
	; Add this font to the menu
	invoke AppendMenu,[lParam],MF_ENABLED + MF_OWNERDRAW,[nItemNum],eax
	inc D[nItemNum]
	
	mov eax,TRUE
	RET
ENDF
